#property copyright "FxAutoRobot"
#property link      "http://FxAutoRobot.com"

extern bool UseOne = FALSE;
extern int NA = 21231;
extern bool UseClose = FALSE;
extern int LP1 = 15;
extern int LM1 = 1;
extern bool UCOT = TRUE;
extern int LP2 = 35;
extern int LM2 = 10;
extern int LP3 = 55;
extern int LM3 = 30;
extern int TralStop = 30;
extern int TralStep = 5;
extern int Slippage = 2;
extern bool ShowComment = TRUE;
extern bool UseSound = TRUE;
extern string NameFileSound = "expert.wav";

void deinit() {
   Comment("");
}

void start() {
   double l_point_0;
   int l_digits_8;
   string ls_12;
   if (true)) {
      ls_12 = "";
      if (UseOne && AccountNumber() != NA) Comment("  : " + AccountNumber() + " !");
      else {
         for (int l_pos_20 = 0; l_pos_20 < OrdersTotal(); l_pos_20++) {
            if (OrderSelect(l_pos_20, SELECT_BY_POS, MODE_TRADES)) {
               if (UseClose || OrderSymbol() == Symbol()) {
                  ThreeLevelSystemOfOutput();
                  l_digits_8 = MarketInfo(OrderSymbol(), MODE_DIGITS);
                  l_point_0 = MarketInfo(OrderSymbol(), MODE_POINT);
                  ls_12 = ls_12 + OrderSymbol() + "  : " + DoubleToStr(OrderOpenPrice(), l_digits_8) + "  SL = " + DoubleToStr(OrderStopLoss(), l_digits_8) + " (" + StopLossInPoint() + ")\n";
               }
            }
         }
         if (ShowComment) Comment(ls_12);
      }
   }
}

void ThreeLevelSystemOfOutput() {
   int li_0 = ProfitPosition();
   int li_4 = StopLossInPoint();
   int li_unused_8 = MarketInfo(OrderSymbol(), MODE_SPREAD);
   if (li_0 > LP1 && li_0 <= LP2 && li_4 < LM1) {
      ModifyStopLossInPoint(LM1);
      if (UCOT) CloseOneThird();
   }
   if (li_0 > LP2 && li_0 <= LP3 && li_4 < LM2) ModifyStopLossInPoint(LM2);
   if (li_0 > LP3 && li_4 < LM3) ModifyStopLossInPoint(LM3);
   if (li_0 > LM3 + TralStop + TralStep) TrailingPositions();
}

void CloseOneThird() {
   bool l_ord_close_0 = FALSE;
   double l_lots_4 = MathCeil(10.0 * (OrderLots() / 3.0)) / 10.0;
   if (l_lots_4 > 0.0) {
      if (OrderType() == OP_BUY) l_ord_close_0 = OrderClose(OrderTicket(), l_lots_4, Bid, Slippage, CLR_NONE);
      if (OrderType() == OP_SELL) l_ord_close_0 = OrderClose(OrderTicket(), l_lots_4, Ask, Slippage, CLR_NONE);
      if (l_ord_close_0 && UseSound) PlaySound(NameFileSound);
   }
}

void TrailingPositions() {
   double l_bid_0;
   double l_ask_8;
   double l_point_16 = MarketInfo(OrderSymbol(), MODE_POINT);
   if (OrderType() == OP_BUY) {
      l_bid_0 = MarketInfo(OrderSymbol(), MODE_BID);
      if (l_bid_0 - OrderOpenPrice() > TralStop * l_point_16) {
         if (OrderStopLoss() < l_bid_0 - (TralStop + TralStep - 1) * l_point_16) {
            ModifyStopLoss(l_bid_0 - TralStop * l_point_16);
            return;
         }
      }
   }
   if (OrderType() == OP_SELL) {
      l_ask_8 = MarketInfo(OrderSymbol(), MODE_ASK);
      if (OrderOpenPrice() - l_ask_8 > TralStop * l_point_16)
         if (OrderStopLoss() > l_ask_8 + (TralStop + TralStep - 1) * l_point_16 || OrderStopLoss() == 0.0) ModifyStopLoss(l_ask_8 + TralStop * l_point_16);
   }
}

void ModifyStopLoss(double a_price_0) {
   int l_bool_8 = OrderModify(OrderTicket(), OrderOpenPrice(), a_price_0, OrderTakeProfit(), 0, CLR_NONE);
   if (l_bool_8 && UseSound) PlaySound(NameFileSound);
}

void ModifyStopLossInPoint(int ai_0) {
   double l_price_4 = 0;
   double l_point_12 = MarketInfo(OrderSymbol(), MODE_POINT);
   if (OrderType() == OP_BUY) l_price_4 = OrderOpenPrice() + ai_0 * l_point_12;
   if (OrderType() == OP_SELL) l_price_4 = OrderOpenPrice() - ai_0 * l_point_12;
   int l_bool_20 = OrderModify(OrderTicket(), OrderOpenPrice(), l_price_4, OrderTakeProfit(), 0, CLR_NONE);
   if (l_bool_20 && UseSound) PlaySound(NameFileSound);
}

int ProfitPosition() {
   double l_bid_0;
   double l_ask_8;
   double l_point_16 = MarketInfo(OrderSymbol(), MODE_POINT);
   double ld_24 = 0;
   if (OrderType() == OP_BUY) {
      l_bid_0 = MarketInfo(OrderSymbol(), MODE_BID);
      ld_24 = (l_bid_0 - OrderOpenPrice()) / l_point_16;
   }
   if (OrderType() == OP_SELL) {
      l_ask_8 = MarketInfo(OrderSymbol(), MODE_ASK);
      ld_24 = (OrderOpenPrice() - l_ask_8) / l_point_16;
   }
   return (MathRound(ld_24));
}

int StopLossInPoint() {
   double l_point_0 = MarketInfo(OrderSymbol(), MODE_POINT);
   double ld_8 = 0;
   if (OrderType() == OP_BUY) ld_8 = (OrderStopLoss() - OrderOpenPrice()) / l_point_0;
   if (OrderType() == OP_SELL) ld_8 = (OrderOpenPrice() - OrderStopLoss()) / l_point_0;
   if (OrderStopLoss() == 0.0) ld_8 = (-OrderOpenPrice()) / l_point_0;
   return (MathRound(ld_8));
}
