
#property indicator_separate_window
#property indicator_minimum 0.0
#property indicator_maximum 1.0
#property indicator_buffers 4
#property indicator_color1 Red
#property indicator_color2 LimeGreen
#property indicator_color3 Gold
#property indicator_color4 Black

extern int Minutes = 5;
double g_ibuf_80[];
double g_ibuf_84[];
double g_ibuf_88[];
double g_ibuf_92[];
double g_isar_96;
double g_iadx_104;
double g_iadx_112;
string gs_120;

int init() {
   SetIndexStyle(0, DRAW_HISTOGRAM, STYLE_SOLID, 2, Red);
   SetIndexBuffer(0, g_ibuf_80);
   SetIndexStyle(1, DRAW_HISTOGRAM, STYLE_SOLID, 2, LimeGreen);
   SetIndexBuffer(1, g_ibuf_84);
   SetIndexStyle(2, DRAW_HISTOGRAM, STYLE_SOLID, 1, Salmon);
   SetIndexBuffer(2, g_ibuf_88);
   SetIndexStyle(3, DRAW_HISTOGRAM, STYLE_SOLID, 1, LightGreen);
   SetIndexBuffer(3, g_ibuf_92);
   switch (Minutes) {
   case 1:
      gs_120 = "Period_M1";
      break;
   case 5:
      gs_120 = "Period_M5";
      break;
   case 15:
      gs_120 = "Period_M15";
      break;
   case 30:
      gs_120 = "Period_M30";
      break;
   case 60:
      gs_120 = "Period_H1";
      break;
   case 240:
      gs_120 = "Period_H4";
      break;
   case 1440:
      gs_120 = "Period_D1";
      break;
   case 10080:
      gs_120 = "Period_W1";
      break;
   case 43200:
      gs_120 = "Period_MN1";
      break;
   default:
      gs_120 = "Current Timeframe";
      Minutes = 0;
   }
   IndicatorShortName("pfd_flat(" + gs_120 + ")");
   return (0);
}

int deinit() {
   return (0);
}

int start() {
//   if (Time[0] > StrToTime("01.02.2010 23:59")) return (0);
   int l_ind_counted_0 = IndicatorCounted();
   for (int li_4 = 0; li_4 < 200; li_4++) {
      g_ibuf_80[li_4] = 0;
      g_ibuf_84[li_4] = 0;
      g_ibuf_88[li_4] = 0;
      g_ibuf_92[li_4] = 0;
      g_iadx_104 = iADX(NULL, Minutes, 14, PRICE_CLOSE, MODE_PLUSDI, li_4);
      g_iadx_112 = iADX(NULL, Minutes, 14, PRICE_CLOSE, MODE_MINUSDI, li_4);
      g_isar_96 = iSAR(NULL, Minutes, 0.02, 0.2, li_4);
      if (g_isar_96 < iClose(NULL, Minutes, li_4) && g_iadx_104 > g_iadx_112) g_ibuf_84[li_4] = 1;
      if (g_isar_96 < iClose(NULL, Minutes, li_4) && g_iadx_112 > g_iadx_104) g_ibuf_92[li_4] = 1;
      if (g_isar_96 > iClose(NULL, Minutes, li_4) && g_iadx_112 > g_iadx_104) g_ibuf_80[li_4] = 1;
      if (g_isar_96 > iClose(NULL, Minutes, li_4) && g_iadx_104 > g_iadx_112) g_ibuf_88[li_4] = 1;
      if (g_ibuf_80[li_4] == 0.0 && g_ibuf_84[li_4] == 0.0) {
      }
   }
   return (0);
}
